// This MFC Samples source code demonstrates using MFC Microsoft Office Fluent User Interface 
// (the "Fluent UI") and is provided only as referential material to supplement the 
// Microsoft Foundation Classes Reference and related electronic documentation 
// included with the MFC C++ library software.  
// License terms to copy, use or distribute the Fluent UI are available separately.  
// To learn more about our Fluent UI licensing program, please visit 
// http://go.microsoft.com/fwlink/?LinkId=238214.
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// CodeEditorView.h : interface of the CCodeEditorView class
//

#pragma once

#define WM_RTF_NUMBER_UPDATE (WM_USER+1000)
#define RTF_NUMBER_RIGHT_MARGIN 60
#define RTF_MARGIN_BKCOLOR RGB(0xFF, 0xF0, 0xFF)
#define RTF_MARGIN_TXCOLOR RGB(0xAF, 0xAF, 0xAF)
#define RTF_MARGIN_SLCOLOR RGB(0x0F, 0x0F, 0x0F)


class CCodeEditorCntrItem;

class CCodeEditorView : public CRichEditView
{
protected: // create from serialization only
	CCodeEditorView();
	DECLARE_DYNCREATE(CCodeEditorView)

// Attributes
public:
	CCodeEditorDoc* GetDocument() const;

// Operations
public:
	afx_msg LRESULT OnRtfNumberUpdate(WPARAM wParam, LPARAM lParam);

// Overrides
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CCodeEditorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	afx_msg void OnDestroy();
	afx_msg void OnFilePrintPreview();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnEnSelchange(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnUpdate();
	afx_msg void OnSize(UINT nType, int cx, int cy);
};

#ifndef _DEBUG  // debug version in CodeEditorView.cpp
inline CCodeEditorDoc* CCodeEditorView::GetDocument() const
   { return reinterpret_cast<CCodeEditorDoc*>(m_pDocument); }
#endif

