// DlgAnsiFile.cpp : implementation file
//

#include "stdafx.h"
#include "CodeEditor.h"
#include "DlgAnsiFile.h"
#include "afxdialogex.h"

#include "char_encoding.h"


// CDlgAnsiFile dialog

IMPLEMENT_DYNAMIC(CDlgAnsiFile, CDialogEx)

ClrVoid CDlgAnsiFile::OnBtnOKClick(ClrObject^, ClrEventArgs^)
{
	ClrAnsiHandler^ ansi_handler
		= this->GetAnsiHandler();

	ClrDataGridView^ hDataGrid =
		ansi_handler->GetAnsiDataGridView();

	ClrDataGridViewRow^ hRow = hDataGrid->CurrentRow;

	if (!hRow)
	{
		AfxMessageBox(L"Please select a valid row");
		this->m_Index = -1;
		return;
	}

	ClrString^ str_index = hRow->Cells[L"ClmIndex"]->Value->ToString();

	this->m_Index = int::Parse(str_index);
	this->EndDialog(IDOK);
}

ClrVoid CDlgAnsiFile::OnBtnCancelClick(ClrObject^, ClrEventArgs^)
{
	this->EndDialog(IDCANCEL);
}


CDlgAnsiFile::CDlgAnsiFile(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_ANSI_TEXT_PREVIEW, pParent)
{
	this->m_str = nullptr;
	this->m_Index = -1;
}

CDlgAnsiFile::~CDlgAnsiFile()
{
}

void CDlgAnsiFile::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_ManagedControl<clr_ansi_handler::AnsiHandler>(pDX, IDC_DATAGRIDVIEW, this->m_AnsiHandler);

}


BEGIN_MESSAGE_MAP(CDlgAnsiFile, CDialogEx)
	ON_WM_SIZE()
END_MESSAGE_MAP()


// CDlgAnsiFile message handlers

void CDlgAnsiFile::FillRows()
{
	if (!this->m_str) return;
	ClrAnsiHandler^ ansi_handler = this->GetAnsiHandler();
	ClrDataGridView^ AnsiDataGrid = 
		ansi_handler->GetAnsiDataGridView();

	CString txt; unsigned int index = 0;

	for (const auto& i : siliners::get_code_page_vctr())
	{
		txt = siliners::mbs_to_cstr(this->m_str, i.second);
		
		if (txt.GetLength() != 0)
		{
			ClrString^ clrstr = gcnew ClrString(txt.GetString());
			ClrString^ langstr = gcnew ClrString(i.first.c_str());
			AnsiDataGrid->Rows->Add(index, langstr, clrstr);
		}

		++index;

	}

}
BOOL CDlgAnsiFile::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	ClrAnsiHandler^ hAnsiHandler = this->GetAnsiHandler();

	ClrButton^ BtnOk = hAnsiHandler->GetBtnOK();
	BtnOk->Click += MAKE_DELEGATE(ClrEventHandler, OnBtnOKClick);


	ClrButton^ BtnCancel = hAnsiHandler->GetBtnCancel();
	BtnCancel->Click += MAKE_DELEGATE(ClrEventHandler, OnBtnCancelClick);

	FillRows();

	// TODO:  Add extra initialization here

	return TRUE;  // return TRUE unless you set the focus to a control
				  // EXCEPTION: OCX Property Pages should return FALSE
}


void CDlgAnsiFile::OnSize(UINT nType, int cx, int cy)
{
	CDialogEx::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here

	if (::IsWindow(this->m_AnsiHandler.GetSafeHwnd()))
	{
		CRect rect; this->GetClientRect(&rect);
		this->m_AnsiHandler.MoveWindow(&rect);
	}
}
