#include "stdafx.h"

namespace siliners
{
	std::vector<std::pair<std::wstring, unsigned int>>
		get_code_page_vctr()
	{
		std::vector<std::pair<std::wstring, unsigned int>>
			code_pages = {
				{ L"IBM EBCDIC US-Canada", 37 },
				{ L"OEM United States", 437 },
				{ L"IBM EBCDIC International", 500 },
				{ L"Arabic (ASMO 708)", 708 },
				{ L"Arabic (ASMO-449, BCON V4)", 709 },
				{ L"Arabic Transparent Arabic", 710 },
				{ L"Arabic (Transparent ASMO); Arabic (DOS)", 720 },
				{ L"OEM Greek (formerly 437G); Greek (DOS)", 737 },
				{ L"OEM Baltic; Baltic (DOS)", 775 },
				{ L"OEM Multilingual Latin 1", 850 },
				{ L"OEM Latin 2; Central European (DOS)", 852 },
				{ L"OEM Cyrillic (primarily Russian)", 855 },
				{ L"OEM Turkish; Turkish (DOS)", 857 },
				{ L"OEM Multilingual Latin 1 + Euro symbol", 858 },
				{ L"OEM Portuguese; Portuguese (DOS)", 860 },
				{ L"OEM Icelandic; Icelandic (DOS)", 861 },
				{ L"OEM Hebrew; Hebrew (DOS)", 862 },
				{ L"OEM French Canadian", 863 },
				{ L"OEM Arabic; Arabic (864)", 864 },
				{ L"OEM Nordic; Nordic (DOS)", 865 },
				{ L"OEM Russian; Cyrillic (DOS)", 866 },
				{ L"OEM Modern Greek; Greek, Modern (DOS)", 869 },
				{ L"IBM EBCDIC Multilingual/ROECE (Latin 2)", 870 },
				{ L"ANSI/OEM Thai (ISO 8859-11); Thai (Windows)", 874 },
				{ L"IBM EBCDIC Greek Modern", 875 },
				{ L"Japanese (Shift-JIS)", 932 },
				{ L"Chinese Simplified (GB2312)", 936 },
				{ L"Korean (Unified Hangul Code)", 949 },
				{ L"Chinese Traditional (Big5)", 950 },
				{ L"IBM EBCDIC Turkish (Latin 5)", 1026 },
				{ L"IBM EBCDIC Latin 1/Open System", 1047 },
				{ L"IBM EBCDIC (US-Canada-Euro)", 1140 },
				{ L"IBM EBCDIC (Germany-Euro)", 1141 },
				{ L"IBM EBCDIC (Denmark-Norway-Euro)", 1142 },
				{ L"IBM EBCDIC (Finland-Sweden-Euro)", 1143 },
				{ L"IBM EBCDIC (Italy-Euro)", 1144 },
				{ L"IBM EBCDIC (Spain-Euro)", 1145 },
				{ L"IBM EBCDIC (UK-Euro)", 1146 },
				{ L"IBM EBCDIC (France-Euro)", 1147 },
				{ L"IBM EBCDIC (International-Euro)", 1148 },
				{ L"IBM EBCDIC (Icelandic-Euro)", 1149 },
				{ L"Unicode UTF-16, little endian BMP of ISO 10646", 1200 },
				{ L"Unicode UTF-16, big endian byte order", 1201 },
				{ L"ANSI Central European", 1250 },
				{ L"ANSI Cyrillic", 1251 },
				{ L"ANSI Latin 1", 1252 },
				{ L"ANSI Greek", 1253 },
				{ L"ANSI Turkish", 1254 },
				{ L"ANSI Hebrew", 1255 },
				{ L"ANSI Arabic", 1256 },
				{ L"ANSI Baltic", 1257 },
				{ L"ANSI/OEM Vietnamese", 1258 },
				{ L"Korean (Johab)", 1361 },
				{ L"Western European (Mac)", 10000 },
				{ L"Japanese (Mac)", 10001 },
				{ L"MAC Traditional Chinese (Big5)", 10002 },
				{ L"Korean (Mac)", 10003 },
				{ L"Arabic (Mac)", 10004 },
				{ L"Hebrew (Mac)", 10005 },
				{ L"Greek (Mac)", 10006 },
				{ L"Cyrillic (Mac)", 10007 },
				{ L"MAC Simplified Chinese (GB 2312)", 10008 },
				{ L"Romanian (Mac)", 10010 },
				{ L"Ukrainian (Mac)", 10017 },
				{ L"Thai (Mac)", 10021 },
				{ L"Central European (Mac)", 10029 },
				{ L"Icelandic (Mac)", 10079 },
				{ L"Turkish (Mac)", 10081 },
				{ L"Croatian (Mac)", 10082 },
				{ L"Unicode UTF-32", 12000 },
				{ L"Unicode UTF-32", 12001 },
				{ L"CNS Taiwan", 20000 },
				{ L"TCA Taiwan", 20001 },
				{ L"Eten Taiwan", 20002 },
				{ L"IBM5550 Taiwan", 20003 },
				{ L"TeleText Taiwan", 20004 },
				{ L"Wang Taiwan", 20005 },
				{ L"IA5 Western European (IA5)", 20105 },
				{ L"IA5 German (7-bit)", 20106 },
				{ L"IA5 Swedish (7-bit)", 20107 },
				{ L"IA5 Norwegian (7-bit)", 20108 },
				{ L"US-ASCII (7-bit)", 20127 },
				{ L"T.61", 20261 },
				{ L"ISO 6937 Non-Spacing Accent", 20269 },
				{ L"IBM EBCDIC Germany", 20273 },
				{ L"IBM EBCDIC Denmark-Norway", 20277 },
				{ L"IBM EBCDIC Finland-Sweden", 20278 },
				{ L"IBM EBCDIC Italy", 20280 },
				{ L"IBM EBCDIC Latin America-Spain", 20284 },
				{ L"IBM EBCDIC United Kingdom", 20285 },
				{ L"IBM EBCDIC Japanese Katakana Extended", 20290 },
				{ L"IBM EBCDIC France", 20297 },
				{ L"IBM EBCDIC Arabic", 20420 },
				{ L"IBM EBCDIC Greek", 20423 },
				{ L"IBM EBCDIC Hebrew", 20424 },
				{ L"IBM EBCDIC Korean Extended", 20833 },
				{ L"IBM EBCDIC Thai", 20838 },
				{ L"Russian (KOI8-R)", 20866 },
				{ L"IBM EBCDIC Icelandic", 20871 },
				{ L"IBM EBCDIC Cyrillic Russian", 20880 },
				{ L"IBM EBCDIC Turkish", 20905 },
				{ L"IBM EBCDIC Latin 1/Open System (1047 + Euro symbol)", 20924 },
				{ L"Japanese (JIS 0208-1990 and 0212-1990)", 20932 },
				{ L"Simplified Chinese (GB2312)", 20936 },
				{ L"Korean Wansung", 20949 },
				{ L"IBM EBCDIC Cyrillic Serbian-Bulgarian", 21025 },
				{ L"(deprecated)", 21027 },
				{ L"Cyrillic (KOI8-U)", 21866 },
				{ L"Western European (ISO)", 28591 },
				{ L"ISO 8859-2 Central European", 28592 },
				{ L"ISO 8859-3 Latin 3", 28593 },
				{ L"ISO 8859-4 Baltic", 28594 },
				{ L"ISO 8859-5 Cyrillic", 28595 },
				{ L"ISO 8859-6 Arabic", 28596 },
				{ L"ISO 8859-7 Greek", 28597 },
				{ L"ISO 8859-8 Hebrew", 28598 },
				{ L"ISO 8859-9 Turkish", 28599 },
				{ L"ISO 8859-13 Estonian", 28603 },
				{ L"ISO 8859-15 Latin 9", 28605 },
				{ L"Europa 3", 29001 },
				{ L"ISO 8859-8 Hebrew; Hebrew (ISO-Logical)", 38598 },
				{ L"ISO 2022 Japanese with no halfwidth Katakana", 50220 },
				{ L"ISO 2022 Japanese with halfwidth Katakana", 50221 },
				{ L"ISO 2022 Japanese JIS X 0201-1989", 50222 },
				{ L"ISO 2022 Korean", 50225 },
				{ L"ISO 2022 Simplified Chinese", 50227 },
				{ L"ISO 2022 Traditional Chinese", 50229 },
				{ L"EBCDIC Japanese (Katakana) Extended", 50930 },
				{ L"EBCDIC US-Canada and Japanese", 50931 },
				{ L"EBCDIC Korean Extended and Korean", 50933 },
				{ L"EBCDIC Simplified Chinese Extended and Simplified Chinese", 50935 },
				{ L"EBCDIC Simplified Chinese", 50936 },
				{ L"EBCDIC US-Canada and Traditional Chinese", 50937 },
				{ L"EBCDIC Japanese (Latin) Extended and Japanese", 50939 },
				{ L"EUC Japanese", 51932 },
				{ L"EUC Simplified Chinese; Chinese Simplified (EUC)", 51936 },
				{ L"EUC Korean", 51949 },
				{ L"EUC Traditional Chinese", 51950 },
				{ L"HZ-GB2312 Simplified Chinese", 52936 },
				{ L"Chinese Simplified (GB18030)", 54936 },
				{ L"ISCII Devanagari", 57002 },
				{ L"ISCII Bangla", 57003 },
				{ L"ISCII Tamil", 57004 },
				{ L"ISCII Telugu", 57005 },
				{ L"ISCII Assamese", 57006 },
				{ L"ISCII Odia", 57007 },
				{ L"ISCII Kannada", 57008 },
				{ L"ISCII Malayalam", 57009 },
				{ L"ISCII Gujarati", 57010 },
				{ L"ISCII Punjabi", 57011 },
				{ L"Unicode (UTF-7)", 65000 },
				{ L"Unicode (UTF-8)", 65001 } };

		return code_pages;
	}

	CString UserDefaultLocaleName()
	{
		wchar_t locale_name[LOCALE_NAME_MAX_LENGTH + 1];
		GetUserDefaultLocaleName(locale_name, LOCALE_NAME_MAX_LENGTH);

		return CString(locale_name);
	}

	// converts multibyte UTF8 to UTF16 CString
	CString utf8_to_cstr(const char* utf)
	{
		size_t utf_len = strlen(utf);
		size_t wcs_len = MultiByteToWideChar(CP_UTF8,
			0, utf, int(utf_len), NULL, NULL);

		if (!wcs_len) return CString("");

		CString cstr;
		// + 1 for null character
		wchar_t* wcs_ptr = cstr.GetBuffer(int(wcs_len + 1));

		size_t uni_len = MultiByteToWideChar(CP_UTF8, 
			0, utf, -1, wcs_ptr, int(wcs_len + 1));

		// successful conversion
		if(uni_len == (wcs_len+1))
		{ 
			cstr.ReleaseBuffer();
			return cstr;
		}
		else
		{
			cstr.ReleaseBuffer();
			return CString(L"");
		}
	}

	// converts multibyte UTF8 to UTF16 CString
	CString mbs_to_cstr(const char* utf, unsigned int code_page)
	{
		size_t utf_len = strlen(utf);
		size_t wcs_len = MultiByteToWideChar(code_page,
			0, utf, int(utf_len), NULL, NULL);

		if (!wcs_len) return CString("");

		CString cstr;
		// + 1 for null character
		wchar_t* wcs_ptr = cstr.GetBuffer(int(wcs_len + 1));

		size_t uni_len = MultiByteToWideChar(code_page,
			0, utf, -1, wcs_ptr, int(wcs_len + 1));

		// successful conversion
		if (uni_len == (wcs_len + 1))
		{
			cstr.ReleaseBuffer();
			return cstr;
		}
		else
		{
			cstr.ReleaseBuffer();
			return CString(L"");
		}
	}

	std::vector<std::pair<std::wstring, std::wstring>>
		get_lang_code_vctr()
	{
		std::vector<std::pair<std::wstring, std::wstring>>
			lang_code =
		{
			/* { L"South-africa",  L"af-ZA"},
			{ L"Czech",         L"cs-CZ" },
			{ L"German-Austrian", L"de-AT" },
			{ L"German-Swiss", L"de-CH" },
			{ L"German-Lichtenstein", L"de-LI" },
			{ L"German-Luxembourg", L"de-LU" },
			{ L"English-Caribbean", L"en-029" },
			{ L"English-Australian", L"en-AU" },
			{ L"English-Belize", L"en-BZ" },
			{ L"English-Canadian", L"en-CA" },
			{ L"English-United Kingdom", L"en-GB" },
			{ L"English-Irish", L"en-IE" },
			{ L"English-Jamaica", L"en-JM" },
			{ L"English-Newzland", L"en-NZ" },
			{ L"English-Trinidad y Tobago", L"en-TT" },
			{ L"English-American ", L"en-US" },
			{ L"English-South africa", L"en-ZA" },
			{ L"Spanish-Argentina", L"es-AR" },
			{ L"Spanish-Bolivia", L"es-BO" },
			{ L"Spanish-Chile", L"es-CL" },
			{ L"Spanish-Colombia", L"es-CO" },
			{ L"Spanish-Costa rica", L"es-CR" },
			{ L"Spanish-Dominican republic", L"es-DO" },
			{ L"Spanish-Ecuador", L"es-EC" },
			{ L"Spanish-Modern", L"es-ES" },
			{ L"Spanish-Guatemala", L"es-GT" },
			{ L"Spanish-Honduras", L"es-HN" },
			{ L"Spanish-Mexican", L"es-MX" },
			{ L"Spanish-Nicaragua", L"es-NI" },
			{ L"Spanish-Panama", L"es-PA" },
			{ L"Spanish-Peru", L"es-PE" },
			{ L"Spanish-Puerto Rico", L"es-PR" },
			{ L"Spanish-Paraguay", L"es-PY" },
			{ L"Spanish-El salvador", L"es-SV" },
			{ L"Spanish-Uruguay", L"es-UY" },
			{ L"Spanish-Venezuela", L"es-VE" },
			{ L"French-Belgian", L"fr-BE" },
			{ L"French-Canadian", L"fr-CA" },
			{ L"French-Swiss", L"fr-CH" },
			{ L"French-Luxembourg", L"fr-LU" }, */
			{ L"Italian-Swiss", L"it-CH" },
			{ L"Korean", L"ko-KR" },
			{ L"Norwegian-Bokma{L", L"nb-NO" },
			{ L"Dutch-Belgian", L"nl-BE" },
			{ L"holland", L"nl-NL" },
			{ L"Norwegian-Nynorsk", L"nn-NO" },
			{ L"Norwegian", L"no" },
			{ L"Portuguese-Brazilian", L"pt-BR" },
			{ L"slovak", L"sk-SK" },
			{ L"Swedish-Finland", L"sv-FI" },
			{ L"Chinese", L"zh" },
			{ L"Chinese-Simplified", L"zh-CN" },
			{ L"Chinese-Hongkong", L"zh-HK" },
			{ L"Chinese-Singapore", L"zh-SG" },
			{ L"Chinese-Traditiona{L", L"zh-TW" } };

		return lang_code;
	}

	CString mbs_to_cstr(const char* mbs, const wchar_t* loc, int cat)
	{
		_locale_t locale = _wcreate_locale(cat, loc);

		size_t wcs_len, mbs_len = locale ?
			_mbslen_l((unsigned char*)mbs, locale) :
			_mbslen((unsigned char*)mbs);

		// returns +1 character to hold null character
		// if successful, return 0, otherwise non-zero
		// wcs_len will hold character length to be converted
		if (locale ? _mbstowcs_s_l(&wcs_len, nullptr, 0, mbs, mbs_len, locale) :
			mbstowcs_s(&wcs_len, nullptr, 0, mbs, mbs_len))
			return CString(L"");

		CString cstr;
		
		wchar_t* wcs = cstr.GetBuffer(int(wcs_len));

		// L'\0' is sappended already
		if (locale ? _mbstowcs_s_l(&wcs_len, wcs, wcs_len, mbs, mbs_len, locale) :
			mbstowcs_s(&wcs_len, wcs, wcs_len, mbs, mbs_len))
		{
			if (locale) _free_locale(locale);
			cstr.ReleaseBuffer();
			return CString(L"");

		}

		cstr.ReleaseBuffer();
		return cstr;
	}
}